<?php

/*
    emailSendEmail.php Gets e-mail information from DB and sends it.


    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.


    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.


    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    or
    http://www.gnu.org/licenses/lgpl-2.1.html


    J+D Software Max-Planck-Straße 6c 63128 Dietzenbach (Germany)
    support@proadsoftware.com
    http://www.proadsoftware.com/meta/impressum */

/*
 * Klasse zum Versand einer E-Mail
 */
//===========================================================================================================
$infos = $GLOBALS['dbloginrow'];
$callParameter = json_decode($infos['specialsession_details']); //Skriptspezifische Paramter (mail_ident)
new MailSender($GLOBALS['dbloginstring'], $callParameter);

//===========================================================================================================
// Innere Klasse, hier wird die Arbeit gemacht
class MailSender {

    var $emailID;
    var $mailAccountUrno;
    var $dbConnection;

//  Ausgabe zur Kontrolle, was wie wo wann wieso übergeben wurde
    function __construct($connectionString, $callParameter) {
        $this->emailID = $callParameter->email_id;
        $this->connectionString = $callParameter->connection_string;

        //echo '<div style="box-shadow: 0px 0px 10px #000;padding:5px;background-color:#aaa;color:white; font-weight:bold;position:fixed;top:20px;right:20px;width:500px;">assignEmail got called with the following params:<br/> uids - ' . $this->uids . ' <br/>table - ' . $this->linkColumn . ' <br/>urnos - ' . $this->urnos. ' <br/>AccUrno - ' . $this->mailAccountUrno . '</div>';


        $this->dbConnection = self::connectToDB($this->connectionString);

        if ($this->dbConnection == false) {
            echo "Could not connect to database";
            return false;
        }


        if (strlen($this->emailID) == 0) {
            echo "No E-Mail ID provided";
            return false;
        }

        $mailArray = self::fetchEmail();
        if ($mailArray == false) {
            echo "Could not retrieve e-mail content";
            return;
        }

        self::sendMail($mailArray);
        self::deleteEmail();            // Löscht immer, auch wenn die Mail nicht verschickt wurde
        return;
    }

    function sendMail($mailArray) {
        // Stammt aus mailserver_db.php sendMail()
        // Das muss noch vereinheitlicht werden
        error_reporting(E_STRICT);

        date_default_timezone_set('Europe/Berlin');

        require_once(__DIR__.'/phpMailer/src/PHPMailer.php');
        require_once(__DIR__.'/phpMailer/src/SMTP.php');
        require_once(__DIR__.'/phpMailer/src/Exception.php');

        $mail = new PHPMailer\PHPMailer\PHPMailer();
        $mail->CharSet = 'UTF-8';

        $from = $mailArray["email_address"];
        $namefrom = $mailArray["author_name"];
        $subject = $mailArray["mail_subject"];
        $message = $mailArray["mail_body"];

        $body = preg_replace("/\\\\/", '', $message);

        $mail->IsSMTP();                                                // telling the class to use SMTP
        $mail->Host = $mailArray["smtp_server"];                        // SMTP server
        $mail->SMTPSecure = $mailArray["smtp_secure"];                  //ssl oder tls

        $senderAdresse = $from;
        $senderKompletterName = $namefrom;

        // TODO: Make smtp useable without smtpAuth
        $mail->SMTPAuth = $mailArray["smtp_auth"];                      // enable SMTP authentication
        $mail->Port = $mailArray["smtp_port"];                          // set the SMTP port for the GMAIL server- 465
        $mail->Username = $mailArray["smtp_user"];                      // SMTP account username
        $mail->Password = $mailArray["smtp_password"];                  // SMTP account password

        $mail->SetFrom($senderAdresse, $senderKompletterName);
        $mail->AddReplyTo($senderAdresse, $senderKompletterName);

        // Adding recipients
        $addresses = explode(';', $mailArray["mail_to"]);
        foreach ($addresses as &$value) {
            $mail->AddAddress($value, $value);
        }

        // Adding CC´s
        $cc = explode(';', $mailArray["mail_cc"]);
        foreach ($cc as &$value) {
            $mail->addCC($value, $value);
        }

        // Adding BCC´s
        $bcc = explode(';', $mailArray["mail_bcc"]);
        foreach ($bcc as &$value) {
            $mail->addBCC($value, $value);
        }


        $mail->Subject = $subject;

        $mail->MsgHTML($body);
        $mail->AltBody = $body;

        //-------------------------------------
        // ADD ATTACHMENT
        //-------------------------------------
        if($mailArray["attachment1_name"] != '') {
            // using urno as suffix makes the temporary name unique
            $attachment_filename = __DIR__ . "/attachment" . $mailArray["urno"];

            // unescape needed to get the raw data
            file_put_contents($attachment_filename,pg_unescape_bytea($mailArray["attachment1"]));

            // add attachment to phpMailer
            $mail->AddAttachment($attachment_filename,$mailArray["attachment1_name"]);
        }
        
        //-------------------------------------
        // SEND MAIL
        //-------------------------------------
        if (!$mail->Send()) {
            echo ( "Error: " . $mail->ErrorInfo);
        } 

        //-------------------------------------
        // DELETE TEMPORARY FILES (ATTACHMENTS)
        //-------------------------------------
        if(isset($attachment_filename)) {
            unlink($attachment_filename);
        }

        return;
    }

    function fetchEmail() {
        $strQuery = "SET bytea_output = 'escape'";

        $dbResult = pg_query($strQuery);

        $strQuery = "SELECT * FROM ems_email where mail_ident = '" . $this->emailID . "'";

        $dbResult = pg_query($strQuery);

        if ($dbResult == false) {
            logMe(pg_last_error());
            return false;
        }

        $arrResult = pg_fetch_array($dbResult, null, PGSQL_ASSOC);
        return $arrResult;
    }

    function deleteEmail() {
        if(strlen($this->emailID)==0){
            return;
        }
            
        $strQuery = "delete FROM ems_email where mail_ident = '" . $this->emailID . "'";
        $dbResult = pg_query($strQuery);
    }


    function connectToDB($strDbConfig) {
        $dbConn = pg_connect($strDbConfig); // or die('DB-Verbindung fehlgeschlagen: ' . pg_last_error());

        if ($dbConn == false) {
// error
            echo "\nDB Error while connecting\n" . pg_last_error() . "\n\n";
            return false;
        }
        return $dbConn;
    }

}
